import {
  getConfig,
  checkResponseForError,
} from "./util";

import {
    fetchWithAuth,
} from "./auth";

import {
  debounceScanner
} from "./scanner";

async function updateDelivery(formField, deliveryUuid) {
  console.log(formField, deliveryUuid);
  var config = await getConfig();
  var response = await fetchWithAuth(config.backend_url + "/delivery/" + deliveryUuid, {
    method: "PUT",
    headers: {
      "Content-Type": "application/json",
    },
    body: JSON.stringify({
      [formField.name] : formField.value,
    })
  });
  if (checkResponseForError(response, "Failed to update delivery " + delivery)) {
    var delivery = await response.json();
    console.log(delivery);
  } 
}

export async function loadDeliveries() {
  console.log("loadDeliveries");
  var config = await getConfig();
  var response = await fetchWithAuth(config.backend_url + "/deliveries");
  if (checkResponseForError(response, "Failed to load deliveries from backend")) {
    var deliveries = await response.json();
    for (var i = 0; i < deliveries.length; i++) {
      /* eslint-disable quotes */
      var delivery = document.getElementById("deliveryTemplate").content.cloneNode(true);
      delivery.firstElementChild.dataset.uuid = deliveries[i].uuid;
      delivery.querySelector('[name="tag"]').textContent = deliveries[i].tag;
      delivery.querySelector('[name="amount"]').textContent = deliveries[i].items.length;
      delivery.querySelector('input[name="addressee"]').value= deliveries[i].addressee;
      delivery.querySelector('input[name="comment"]').value = deliveries[i].comment;
      for (var j = 0; j < deliveries[i].items.length; j++) {
        var item = document.getElementById("itemTemplate").content.cloneNode(true);
        item.querySelector('div[name="storage"]').textContent = deliveries[i].items[j].storage_name;
        delivery.querySelector(".itemList").append(item);
      }
      delivery.querySelector('[name="title"]').onclick = function() {
        var itemList = this.closest(".delivery").nextElementSibling;
        if (itemList.classList.contains("show")) {
          itemList.classList.remove("show");
        } else {
          itemList.classList.add("show");
        }
      };
      delivery.querySelectorAll("input").forEach(function (element) {
        element.onchange = function() {
          updateDelivery(this, this.closest(".delivery").parentNode.dataset.uuid);
        };
      });
      document.querySelector(".container").appendChild(delivery);
      /* eslint-enable */
    }
  }
}
